;*DDK*************************************************************************/
;
; COPYRIGHT (C) Microsoft Corporation, 1989
; COPYRIGHT    Copyright (C) 1995 IBM Corporation
;
;    The following IBM OS/2 WARP source code is provided to you solely for
;    the purpose of assisting you in your development of OS/2 WARP device
;    drivers. You may use this code in accordance with the IBM License
;    Agreement provided in the IBM Device Driver Source Kit for OS/2. This
;    Copyright statement may not be removed.;
;*****************************************************************************/
        page    ,132
;/*****************************************************************************
;*
;* SOURCE FILE NAME = HWDATA.ASM
;*
;* DESCRIPTIVE NAME = Hardware configuration data
;*
;*
;* VERSION      V2.0
;*
;* DATE         03/07/88
;*
;* DESCRIPTION  
;*
;*    This module contains the configuration dependent data for the various
;*    hardware configurations of the 8514/A adapter. This file is part of the
;*    device dependent sources.
;* 
;*    Static hardware specific data which must be public is also defined here.
;*
;* FUNCTIONS    NONE
;*                                            
;* NOTES        NONE                          
;*                                            
;* STRUCTURES   NONE                       
;*                                            
;* EXTERNAL REFERENCES                                             
;*
;*              NONE
;*
;* EXTERNAL FUNCTIONS
;*
;*              NONE
;*
;* CHANGE ACTIVITY =
;*   DATE      FLAG        APAR   CHANGE DESCRIPTION
;*   --------  ----------  -----  --------------------------------------
;*   mm/dd/yy  @Vr.mpppxx  xxxxx  xxxxxxx
;*   03/07/88                     Author:  Geoff Shapiro [geoffs]
;*
;*****************************************************************************/

        .286p

        .xlist
        include cmacros.inc
        include pmgre.inc
DINCL_ROPS      equ     1
        include driver.inc
        include 8514.inc
        .list

        ??_out  hwdata

;/*
;** translate table of hardware mix modes
;*/

hwMixes_table   macro
        db      FUNC_ZEROS
        db      FUNC_NS_AND_ND
        db      FUNC_NS_AND_D
        db      FUNC_NS
        db      FUNC_S_AND_ND
        db      FUNC_ND
        db      FUNC_S_XOR_D
        db      FUNC_NS_OR_ND
        db      FUNC_S_AND_D
        db      FUNC_S_XNOR_D
        db      FUNC_D
        db      FUNC_NS_OR_D
        db      FUNC_S
        db      FUNC_S_OR_ND
        db      FUNC_S_OR_D
        db      FUNC_ONES
        .errnz  ROP_DDX  - 0
        .errnz  ROP_DPON - 1
        .errnz  ROP_DPNA - 2
        .errnz  ROP_PN   - 3
        .errnz  ROP_PDNA - 4
        .errnz  ROP_DN   - 5
        .errnz  ROP_DPX  - 6
        .errnz  ROP_DPAN - 7
        .errnz  ROP_DPA  - 8
        .errnz  ROP_DPXN - 9
        .errnz  ROP_D    - 10
        .errnz  ROP_DPNO - 11
        .errnz  ROP_P    - 12
        .errnz  ROP_PDNO - 13
        .errnz  ROP_DPO  - 14
        .errnz  ROP_DDXN - 15
        endm

sBegin  Code
        assumes Cs,Code
        public  hwMixes
hwMixes label   byte
        hwMixes_table
        public  hwMixes_tblSize
hwMixes_tblSize equ     $ - hwMixes

        public  FarhwMixes
FarhwMixes label   byte
        hwMixes_table
sEnd    Code

ifdef   8514DEBUG

sBegin  HwConfig
        assumes Cs,HwConfig

        Public  HwConfig0Funcs
HwConfig0Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig1Funcs
HwConfig1Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig2Funcs
HwConfig2Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig3Funcs
HwConfig3Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig4Funcs
HwConfig4Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig5Funcs
HwConfig5Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig6Funcs
HwConfig6Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions

        Public  HwConfig7Funcs
HwConfig7Funcs  Label   Dword
        Dd      ?                                 ; ->s configuration specific functions
sEnd

endif;  8514DEBUG

        End
