/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT (C) Lexmark Corporation, 1989                                   */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *                            Lexmark Confidential
 *
 * SOURCE FILE NAME = PRDTYPET
 *
 * DESCRIPTIVE NAME = Printer Device Driver Types
 *
 *
 * VERSION
 *
 * DATE
 *
 * DESCRIPTION
 *
 * FUNCTIONS
 *
 * ENTRY POINTS:
 *
 * DEPENDENCIES:
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/


/**********************************************************************/
/* Type definitions for the DC Instance Data and the Device Driver's  */
/* view of DC.                                                        */
/* Should remove this and use HDC (the OS/2 defined type)             */
/**********************************************************************/
typedef ULONG      hanDC;

/**********************************************************************/
/* World coordinate type                                              */
/**********************************************************************/
typedef struct
    {
        LONG   X;
        LONG   Y;
    } WcsPoint;

/**********************************************************************/
/* Device coordinate type                                             */
/**********************************************************************/
typedef struct
    {
        SHORT  X;
        SHORT  Y;
    } DevPoint;

/**********************************************************************/
/* World coordinate rectangle type                                    */
/**********************************************************************/
typedef WcsPoint WcsRect[2];

/**********************************************************************/
/* Device coordinate rectangle type                                   */
/**********************************************************************/
typedef DevPoint DevRect[2];

/**********************************************************************/
/* DDState enumerates the global state of the Device Driver.          */
/**********************************************************************/
enum DDState
    {
        prd_Reset,                    /* not initialised             */
        prd_Ready,                    /* initialised and running     */
        prd_Error                     /* error and terminating       */
    };

/**********************************************************************/
/* Information required to lock a DC.                                 */
/**********************************************************************/
typedef struct
{
    USHORT    LockCount;
/* TID        tidLock;     CON3201 */
    ULONG     tidLock;
} LockDCInfoStruct;

