/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT (C) Microsoft Corporation, 1989                                 */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = DIALOG.H
 *
 * DESCRIPTIVE NAME = PLOTTER DRIVER SOURCE
 *
 *
 * VERSION = V2.0
 *
 * DATE        12/12/88
 *
 * DESCRIPTION  PLOTTER DRIVER SOURCE HEADER FILE
 *
 *
 * FUNCTIONS
 *
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/

#define  IDM_MAINMENU  10
#define  IDM_CAROUSEL  11
#define  IDM_PENCOLOR  12
#define  IDM_PENTYPE   13
#define  IDM_OPTIONS   14
#define  IDM_HELP      15

#define  IDD_SETUPDLG  20
#define  IDD_OPTIONS   21
#define  IDD_OPTIONS_FORCE 22
#define  IDD_OPTIONS_ACCEL 23
#define  IDD_PRIORITY  24
#define  IDD_PENCOLOR  25

#define  IDD_HELP      26
#define  IDD_SETUPDLG_VERSION 27       /* DCR1399                           */

#define  IDM_HELPINDEX 30
#define  IDM_HELPEXTENDED 31
#define  IDM_HELPKEYS  32
#define  IDM_HOWTOGETHELP 33

#define  COLORPRO      64
#define  HP7470A       65
#define  HP7475A       66
#define  HP7550A       67
#define  HP7580A       68
#define  HP7585A       69
#define  HP7580B       70
#define  HP7585B       71
#define  HP7586B       72
#define  DRAFTPRO      73
#define  DRAFTMASTER1  74
#define  DRAFTMASTER2  75
#define  IBM6180       76
#define  IBM7371       77
#define  IBM7372       78
#define  IBM6182       79
#define  IBM7374       80
#define  IBM7375_1     81
#define  IBM7375_2     82
#define  IBM6184       83
#define  IBM6186_1     84
#define  IBM6186_2     85
#define  PAINTJET_XL   86
#define  DESIGNJET200  87
#define  DESIGNJET220  88
#define  DESIGNJET600  89
#define  DESIGNJET650C 90
#define  PAINTJET_XL300 91
#define  DRAFTMASTER_SX 92
#define  DRAFTMASTER_RX 93
#define  DRAFTMASTER_MX 94
#define  LASERJET4      95
#define  HPC3170A       96

#define  SELECT_PEN_COLOR 100

/* The following defines for the colors MUST be sequential and the
** .RC file must have a one to one correlation!
*/
#define  YELLOW        700
#define  ORANGE        701
#define  RED           702
#define  GREEN         703
#define  RED_VIOLET    704
#define  CYAN          705
#define  VIOLET        706
#define  BLUE          707
#define  BROWN         708
#define  BLACK         709
#define  WHITE         710
#define  GRAY          711
#define  DARKBLUE      712
#define  DARKRED       713
#define  DARKPINK      714
#define  DARKGREEN     715
#define  DARKCYAN      716
#define  DARKGRAY      717
#define  LIGHTGRAY     718
#define  REDGRAY       719
#define  GREENGRAY     720
#define  BLUEGRAY      721

#define  BLUSH                            722
#define  LIGHTRED                         723
#define  CRIMSON                          724
#define  BRICKRED                         725
#define  BRICKGRAY                        726
#define  SAND                             727
#define  SALMON                           728
#define  PUMPKIN                          729
#define  CHESTNUT                         730
#define  SIENNABROWN                      731
#define  TAN                              732
#define  DARKTAN                          733
#define  BUFF                             734
#define  LIGHTPEACH                       735
#define  DARKPEACH                        736
#define  LIGHTBROWN                       737
#define  DARKBROWN                        738
#define  IVORY                            739
#define  DARKIVORY                        740

#define  PARCHMENT                        741
#define  PALEYELLOW                       742
#define  GOLD                             743
#define  DARKGOLD                         744
#define  UMBER                            745
#define  STRAW                            746
#define  DARKSTRAW                        747
#define  PALEGREEN                        748
#define  LIGHTGREEN                       749
#define  LEAFGREEN                        750
#define  DEEPGREEN                        751
#define  MOSS                             752
#define  DARKMOSS                         753
#define  MINTGREEN                        754
#define  SEAGREEN                         755
#define  LIGHTEMERALD                     756
#define  EMERALD                          757
#define  DARKEMERALD                      758
#define  EVERGREEN                        759
#define  DARKGREENGRAY                    760
#define  SEAFOAM                          761
#define  LIGHTAQUA                        762
#define  AQUA                             763
#define  TURQUOISE                        764
#define  SPRUCE                           765
#define  SEAGRAY                          766
#define  SPRUCEGRAY                       767
#define  PASTELBLUE                       768
#define  BABYBLUE                         769
#define  SKYBLUE                          770
#define  CERULEAN                         771
#define  TRUEBLUE                         772
#define  SLATEBLUE                        773
#define  COOLGRAY                         774
#define  COLDGRAY                         775
#define  ICEBLUE                          776
#define  CORNFLOWER                       777
#define  DUSTYBLUE                        778
#define  ROYALBLUE                        779
#define  FLAGBLUE                         780
#define  MIDNIGHTBLUE                     781
#define  DARKBLUEGRAY                     782
#define  LAVENDAR                         783
#define  DARKLAVENDAR                     784
#define  LILAC                            785
#define  DARKVIOLET                       786
#define  INDIGO                           787
#define  LILACGRAY                        788
#define  VIOLETGRAY                       789
#define  PURPLEWASH                       790
#define  PALEPURPLE                       791
#define  LIGHTPURPLE                      792
#define  PURPLE                           793
#define  GRAPE                            794
#define  DARKGRAPE                        795
#define  LIGHTPURPLEGRAY                  796
#define  PURPLEGRAY                       797
#define  PALEPINK                         798
#define  HOTPINK                          799
#define  LIGHTMAGENTA                     800
#define  MAGENTA                          801
#define  DARKMAGENTA                      802
#define  PLUM                             803
#define  LIGHTPLUMGRAY                    804
#define  PLUMGRAY                         805
#define  PALEROSE                         806
#define  LIGHTROSE                        807
#define  ROSE                             808
#define  DARKROSE                         809
#define  BURGUNDY                         810
#define  DARKBURGUNDY                     811
#define  SANDSTONE                        812
#define  DARKSANDSTONE                    813
#define  D3PCTGRAY                        814
#define  D6PCTGRAY                        815
#define  D13PCTGRAY                       816
#define  D19PCTGRAY                       817
#define  D31PCTGRAY                       818
#define  D38PCTGRAY                       819
#define  D44PCTGRAY                       820
#define  D56PCTGRAY                       821
#define  D63PCTGRAY                       822
#define  D69PCTGRAY                       823
#define  D75PCTGRAY                       824
#define  D81PCTGRAY                       825

/* This is the last color -- "none"
*/
#define  NO_COLOR                         826

#define  P3            140
#define  P7            141
#define  T3            142
#define  T6            143
#define  V25           144
#define  V35           145
#define  V50           146
#define  V70           147
#define  R3            148
#define  D018          149
#define  D025          150
#define  D035          151
#define  D050          152
#define  D070          153
#define  D100          154
#define  D012          155  // Added a new pen width
// this should not be "sorted" because you take which ever pen the user
// selected in the dialog (ex D035) and subtract the first pen (P3) from that.
// This gives an index into the structures. @MARK

#define  SIZE_A        160
#define  SIZE_B        161
#define  SIZE_C        162
#define  SIZE_D        163
#define  SIZE_E        164
#define  SIZE_A4       165
#define  SIZE_A3       166
#define  SIZE_A2       167
#define  SIZE_A1       168
#define  SIZE_A0       169
#define  SIZE_24       170
#define  SIZE_36       171
#define  SIZE_AB       172
#define  SIZE_AC       173
#define  SIZE_AD       174
#define  SIZE_AE       175

#define  ROLL_24       177
#define  ROLL_36       178

#define  SPEED         180
#define  FORCE         181
#define  ACCELERATION  182
#define  USAGE         183

#define  RGB_MODE      184
#define  CAROUSEL_MODE 185

#define  SEL_CAROUSEL1 200
#define  SEL_CAROUSEL2 201
#define  SEL_CAROUSEL3 202
#define  SEL_CAROUSEL4 203
#define  SEL_CAROUSEL5 204
#define  SEL_CAROUSEL6 205
#define  SEL_CAROUSEL7 206
#define  SEL_CAROUSEL8 207
#define  SEL_CAROUSEL9 208
#define  SEL_CAROUSEL10 209

#define  ACTIVE_CAROUSEL1 220
#define  ACTIVE_CAROUSEL2 221
#define  ACTIVE_CAROUSEL3 222
#define  ACTIVE_CAROUSEL4 223
#define  ACTIVE_CAROUSEL5 224
#define  ACTIVE_CAROUSEL6 225
#define  ACTIVE_CAROUSEL7 226
#define  ACTIVE_CAROUSEL8 227
#define  ACTIVE_CAROUSEL9 228
#define  ACTIVE_CAROUSEL10 229

#define MANUAL                      301
#define AUTOMATIC                   302
#define PRELOADED                   303
#define PORTRAIT                    304
#define LANDSCAPE                   305
#define ROLL_LENGTH                 306
#define ROLL_SCROLL                 307
#define ROLL_TEXT1                  309
#define ROLL_TEXT2                  310
#define MEDIA_SIZE                  311
#define SIZE_TEXT                   312
#define RESET                       313
#define SAVE                        314
#define OPTION_UNITS                315
#define PEN_VARIABLE                325
#define OPT_SCROLL                  326
#define USE_NONE                    327
#define USE_LINE                    328
#define USE_FILL                    329
#define USE_TEXT                    330
#define DRAFT                       347
#define GEC                         348
#define COLORSORT                   349
#define FORMNAME                    350
#define RGB_OR_CAROUSEL_MODE        351
#define PENTEXT                     352
#define COLORTEXT                   353
#define TYPETEXT                    354
#define CAROUSELTEXT                355
#define UNCOLLATED_COPIES           356
#define UNCOLLATED_COPIES_TEXT      357
#define USER_DEFINED_FORMS          358
#define HPGL2_RASTER                359

#define  CM_SECOND                  400
#define  GRAMS                      401
#define  GRAVITY                    402
#define  CAROUSEL                   403
#define  CAROUSELNUM                404
#define  ACTIVE_CAROUSEL            405
#define  SELECT_ALL                 406
#define  SELECT_NONE                407

#define  NEWSHEET1                  500
#define  NEWCAROUSEL1               510
#define  NEWCAROUSEL2               511
#define  NEWCAROUSEL3               512
#define  WRITE_ERR                  513

#define  CAROUSEL_PEN1              600
#define  CAROUSEL_PEN2              601
#define  CAROUSEL_PEN3              602
#define  CAROUSEL_PEN4              603
#define  CAROUSEL_PEN5              604
#define  CAROUSEL_PEN6              605
#define  CAROUSEL_PEN7              606
#define  CAROUSEL_PEN8              607
#define  CAROUSEL_COLOR1            610
#define  CAROUSEL_COLOR2            611
#define  CAROUSEL_COLOR3            612
#define  CAROUSEL_COLOR4            613
#define  CAROUSEL_COLOR5            614
#define  CAROUSEL_COLOR6            615
#define  CAROUSEL_COLOR7            616
#define  CAROUSEL_COLOR8            617
#define  CAROUSEL_TYPE1             620
#define  CAROUSEL_TYPE2             621
#define  CAROUSEL_TYPE3             622
#define  CAROUSEL_TYPE4             623
#define  CAROUSEL_TYPE5             624
#define  CAROUSEL_TYPE6             625
#define  CAROUSEL_TYPE7             626
#define  CAROUSEL_TYPE8             627
#define  CAROUSEL_VAR1              630
#define  CAROUSEL_VAR2              631
#define  CAROUSEL_VAR3              632
#define  CAROUSEL_VAR4              633
#define  CAROUSEL_VAR5              634
#define  CAROUSEL_VAR6              635
#define  CAROUSEL_VAR7              636
#define  CAROUSEL_VAR8              637

#define  IDC_LISTBOX                650

/*
** Entries added for DCR 1476
*/
#define  IDS_HELPTITLE    900           /* help strings                     */
#define  IDS_NoHelpFile   901
#define  IDS_NoHelpMemory 902

/*
**  main help table
*/
#define  MAIN_HELPTABLE 1000

/*
**  help subtables
*/
#define  IDD_MAIN_SUBTABLE          1010
#define  IDD_PRIORITY_SUBTABLE      1011
#define  IDD_OPTIONS_SPEED_SUBTABLE 1012
#define  IDD_OPTIONS_FORCE_SUBTABLE 1013
#define  IDD_OPTIONS_ACCEL_SUBTABLE 1014
#define  DUMMY_SUBTABLE             1015

/*
**  help panels
*/
#define  IDH_OK                 1090
#define  IDH_CANCEL             1091
#define  IDH_RESET              1092
#define  IDH_HELP               1190
#define  IDH_HOWTOGETHELP       1191
#define  IDH_HELPEXTENDED       1192
#define  IDH_HELPKEYS           1193
#define  IDH_HELPINDEX          1194
#define  IDH_KEYS              15010
#define  IDH_PENSPEED          15150
#define  IDH_PENSPEED_DLG      15151
#define  IDH_FORCE             15152
#define  IDH_FORCE_DLG         15153
#define  IDH_ACCELERATION      15154
#define  IDH_ACCELERATION_DLG  15155
#define  IDH_PRIORITY          15156
#define  IDH_PRIORITY_DLG      15157
#define  IDH_COLORSORTING      15158
#define  IDH_GEC               15159
#define  IDH_ENTER             15160
#define  IDH_PROPERTIES        15390
#define  IDH_FEED              15391
#define  IDH_ORIENTATION       15392
#define  IDH_SIZE              15393
#define  IDH_CAROUSEL          15394
#define  IDH_SELECT            15395
#define  IDH_PEN               15396
#define  IDH_PENCOLOR          15397
#define  IDH_TYPE              15398
#define  IDH_OPTIONS           15399
#define  IDH_ABOUT_PLOTTER_DRV 15416

#define IDD_USER_DEFINED_FORMS      1200
#define USER_FORM_LIST              1201
#define ADD_USER_FORM               1202
#define DELETE_USER_FORM            1203
#define MODIFY_USER_FORM            1204
#define USER_FORM_NAME_TEXT         1205
#define USER_FORM_NAME              1206
#define USER_WIDTH_TEXT             1207
#define USER_HEIGHT_TEXT            1208
#define USER_FORM_WIDTH             1209
#define USER_FORM_HEIGHT            1210
#define USER_UNITS_GROUP            1211
#define USER_INCHES                 1212
#define USER_CENTIMETERS            1213
#define USER_CLEAR_FIELDS           1214
#define USER_FORM_ID                1216
#define USER_FORM_ID_TEXT           1215

/*
**  Error entries
*/
#define IDS_ErrorTitle              903
#define IDS_CoruptIniData           904
#define IDS_FillInAllFields         905
#define IDS_FormConflictWithID      906
#define IDS_FormConflictWithName    907
#define IDS_NoFormSelected          908
