/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT (C) Microsoft Corporation, 1989                                 */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = font.h
 *
 * DESCRIPTIVE NAME = PLOTTER DRIVER SOURCE
 *
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION   Define globally available functions & data in file font.c
 *
 *
 * FUNCTIONS
 *
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/
#define  FONTWEIGHT    5
#define  FIRSTCHAR     32
#define  LASTCHAR      255             /* Perhaps this should be 315?       */
#define  DEFAULTCHAR   ('.'-FIRSTCHAR)
#define  BREAKCHAR     (32-FIRSTCHAR)
#define  PLOTTER_FONT_MATCH (-234L)    /* Some arbitrary negative number    */

/*
** Return mode flags for cpxfm_metrics
*/
#define CPXFM_RET_WORLD   0x0000         /* Function should return World FM  */
#define CPXFM_RET_DEVICE  0x0001         /* Function should return Device FM */



/*
**  Functions removed from textout.c
*/
extern BOOL  DeviceQueryFontAttributes ( HDC, LONG, PFONTMETRICS,
                                                   PDDC, ULONG );
extern LONG  DeviceQueryFonts ( HDC, ULONG, PSZ, PFONTMETRICS, LONG,
                                          PLONG, PDDC, ULONG );
extern LONG  RealizeFont ( HDC, ULONG, PFATTRS, ULONG, PDDC, ULONG );

/*
**  New functions created in font.c
*/
extern LONG  QueryTextBox ( HDC, ULONG, PCH, LONG, PPOINTL, PDDC,
                                      ULONG );
extern LONG  QueryCharPositions ( HDC, PPOINTL, ULONG, LONG, PCH,
                                            PLONG, PPOINTL, PDDC, ULONG );
extern BOOL  QueryWidthTable ( HDC, LONG, LONG, PLONG, PDDC, ULONG );

extern BOOL  cpxfm_metrics(HDC, PFONTMETRICS, PFONTMETRICS, USHORT, BOOL, PDDC,
                           USHORT, USHORT);
