/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT (C) Microsoft Corporation, 1989                                 */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = PRDSTYPT.H
 *
 * DESCRIPTIVE NAME =
 *
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION : Printer Device Driver semaphore type definitions
 *
 * FUNCTIONS
 *
 * NOTES       : Reference - Device Driver Interface Specification
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/


typedef struct
    {
	ULONG Status;
    } SemaphoreType;

typedef SemaphoreType *Semaphore;

typedef struct
    {
	PSZ	 DeviceName;
	Semaphore ControlSemaphore;
	Semaphore DosSemaphore;
	Semaphore BandSemaphore;
	Semaphore FontSemaphore;
	SHORT	   ThreadID;
    } DeviceSemaphoreTableEntry;

typedef DeviceSemaphoreTableEntry *DeviceSemaphoreTable;

typedef struct ShortLinetag
    {
	ULONG		  Style;
	SHORT		   XStart;
	SHORT		   YStart;
	SHORT		   XStop;
	SHORT		   YStop;
	SHORT		   BBoxLeft;
	SHORT		   BBoxRight;
	struct ShortLinetag *NextShortLine;
	struct ShortLinetag *PreviousShortLine;
	SHORT		   StartOfList;
    } ShortLine;

typedef ShortLine *pShortLine;

typedef struct scans_data
    {
	pShortLine FirstLeft;
	pShortLine LastLeft;
	pShortLine FirstRight;
	pShortLine LastRight;
	SHORT	   NumberOfPairs;
	DevRect   CoordRect;
    } ScanLine;

typedef ScanLine *pScanLine;
